include('FPGAburn/appload.py') # must be on the first line

# test the fft procedures

  ljmp(fwd('init'))

include('lib/hexio.py')
include('lib/profile.py')

def12('passes', 5) # 3..9
def12('points', 1 << passes) # 8..512
include('lib/fft.py')

# timestamps
lbl('t1'); data([0,0,0,0])
lbl('t2'); data([0,0,0,0])

# keystroke command procedures

lbl('print_buf_adr'); data([0])
#
lbl('print_buf') # adr ->
# print the selected buffer of size points
  lst(print_buf_adr); lcall(cr) # ->
  lit(0) # -> index
lbl('print_buf_loop')
    tt(); lbxor(points); ljz(fwd('print_buf_done'))
      tt(); lld(print_buf_adr); add(); ld(); lcall(printx); lcall(sp)
      inc() # -> index'
      ljmp(print_buf_loop)
lbl('print_buf_done')
  drop(); ljmp(cr) # ->

lbl('dump_brev') # keystroke ->
# print brev
  lcall(tx) # -> # echo
  lit(brev); ljmp(print_buf)

lbl('dump_real') # keystroke ->
# print real
  lcall(tx) # -> # echo
lbl('dump_real_') # ->
  lit(real); ljmp(print_buf)

lbl('dump_imag') # keystroke ->
# print imag
  lcall(tx) # -> # echo
lbl('dump_imag_') # ->
  lit(imag); ljmp(print_buf)

lbl('dump_cos') # keystroke ->
# print cos
  lcall(tx) # -> # echo
  lit(cos); ljmp(print_buf)

lbl('dump_sin') # keystroke ->
# print sin
  lcall(tx) # -> # echo
  lit(sin); ljmp(print_buf)

lbl('real_in_adr'); data ([0])
lbl('real_in_i'); data ([0])
#
lbl('real_in') # adr ->
# copy array at adr to real in bit-reversed order, imag is zeroed
  lst(real_in_adr); lit(0); lst(real_in_i) # ->
lbl('real_in_loop')
    lld(real_in_i); lbxor(points); ljz(fwd('real_in_done'))
      lld(real_in_adr); lld(real_in_i); ald() # -> d
      lld(real_in_i); lald(brev); last(real) # ->
      lit(0); lld(real_in_i); last(imag)
      lld(real_in_i); inc(); lst(real_in_i)
      ljmp(real_in_loop)
lbl('real_in_done')
  ret()

lbl('fft_Cos') # keystroke ->
# fft of a real input sequence of 1 cycle of cos
  lcall(tx) # -> # echo
  lit(cos); lcall(real_in)
  lit(t1); lcall(log_time)
  lcall(fft)
  lit(t2); lcall(log_time)
  lcall(dump_real_); lcall(dump_imag_)
  lit(t1); lit(t2); ljmp(print_delta_t)

lbl('fft_Sin') # keystroke ->
# fft of a real input sequence of 1 cycle of sin
  lcall(tx) # -> # echo
  lit(sin); lcall(real_in)
  lit(t1); lcall(log_time)
  lcall(fft)
  lit(t2); lcall(log_time)
  lcall(dump_real_); lcall(dump_imag_)
  lit(t1); lit(t2); ljmp(print_delta_t)

lbl('command') # ->
# respond to USB/UART keystrokes
  lld(rx_status); ljz(fwd('no_command'))
    lld(uart) # -> keystroke
    lcall(cr) # newline on console
    # resolve defined keystroke commands
    tt(); lbxor(ord('b')); ljz(dump_brev)
    tt(); lbxor(ord('r')); ljz(dump_real)
    tt(); lbxor(ord('i')); ljz(dump_imag)
    tt(); lbxor(ord('c')); ljz(dump_cos)
    tt(); lbxor(ord('s')); ljz(dump_sin)
    tt(); lbxor(ord('C')); ljz(fft_Cos)
    tt(); lbxor(ord('S')); ljz(fft_Sin)
    ljmp(tx) # -> # echo none of the above
lbl('no_command')
  ret()

# the app

lbl('init')
  lcall(set_brev)
lbl('doit')
    lcall(command)
    ljmp(doit)

lbl('app_end') # must be on the last line
