include('FPGAburn/appload.py') # must be on the first line

# test fm25v20a SPI FRAM

  ljmp(fwd('init'))

include('lib/hexio.py')
include('lib/spi.py')
include('lib/fm25v20a.py')

def12('words', int(16)) # buf words
def12('dwords', int(words/2)) # buf dwords

lbl('write_buf'); data([int(MAXPOS*math.sin(n*math.tau/words)) for n in range(words)])
lbl('read_buf'); data([0 for n in range(words)])
lbl('buf_index'); data([0])

# keystroke command procedures

lbl('print_buf') # adr ->
# print the selected buffer
  lit(0); lst(buf_index); lcall(cr)
lbl('print_buf_loop')
    lld(buf_index); lbxor(words); ljz(fwd('print_buf_done'))
      tt(); lld(buf_index); add(); ld(); lcall(printx); lcall(sp)
      lld(buf_index); inc(); lst(buf_index)
      ljmp(print_buf_loop)
lbl('print_buf_done')
  drop(); ljmp(cr) # -> # drop adr

lbl('got_write') # keystroke ->
# copy write_buf to fram
  drop() # ->
  lit(write_buf) # -> adr
  tt(); lit(dwords); lit(0); lit(0); lit(0); lit(spi_fram1); lcall(fram_write)
  ljmp(print_buf)

lbl('got_read') # keystroke ->
# copy fram to read_buf
  drop() # ->
  lit(read_buf) # -> adr
  tt(); lit(dwords); lit(0); lit(0); lit(0); lit(spi_fram1); lcall(fram_read)
  ljmp(print_buf)

lbl('command') # ->
# respond to USB/UART keystrokes
  lld(rx_status); ljz(fwd('no_command'))
    lld(uart) # -> keystroke
    tt(); lcall(tx) # echo
    # resolve defined keystroke commands
    tt(); lbxor(ord('w')); ljz(got_write)
    tt(); lbxor(ord('r')); ljz(got_read)
    drop() # -> # none of the above, drop keystroke
lbl('no_command')
  ret()

# the app

lbl('init')
  # nothing to init
lbl('doit')
    lcall(command)
    ljmp(doit)

lbl('app_end') # must be on the last line
