include('FPGAburn/appload.py') # must be on the first line

# play some squarewaves on po_o[1] without disturbing other po bits
# blink D7 on po_o[0] without disturbing other po bits
# demonstrate sqw_task, chirp_task, blink_task

  ljmp(fwd('init'))

include('lib/tardy.py')

# squarewave edge periods based on t23
def12('sqw_minp', int(fclk/2**12/2000)) # ~1 kHz
def12('sqw_maxp', int(fclk/2**12/160)) # ~80 Hz

# chirp period based on t35
def12('chirp_p', int(0.5/tclk/2**24)) # ~0.5 s

# blink period based on t35
def12('blink_p', int(1/tclk/2**24)) # ~1 s

# scheduling
lbl('sqw_wakeup'); data([0])
lbl('sqw_period'); data([sqw_minp])
lbl('chirp_wakeup'); data([0])
lbl('chirp_period'); data([chirp_p])
lbl('blink_wakeup'); data([0])
lbl('blink_period'); data([blink_p])

lbl('next_sqw') # ->
# schedule next square wave edge
  lld(sqw_period); lld(sqw_wakeup); add(); lst(sqw_wakeup); ret()

lbl('next_chirp') # ->
# schedule next chirp step
  lld(chirp_period); lld(chirp_wakeup); add(); lst(chirp_wakeup); ret()

lbl('next_blink') # ->
# schedule next blink
  lld(blink_period); lld(blink_wakeup); add(); lst(blink_wakeup); ret()

lbl('downchirp') # ->
# wrap sqw_period between sqw_minp and sqw_maxp
  lld(sqw_period); inc() # -> per'
  tt(); lbxor(sqw_maxp+1); ljz(fwd('downchirp_wrap')) # -> per'
    lst(sqw_period); ret()
lbl('downchirp_wrap')
  drop() # ->
  lit(sqw_minp); lst(sqw_period); ret()

lbl('sqw_task') # ->
# squarewave edge task
  lld(sqw_wakeup); lit(t23); lcall(tardy); ljz(fwd('sqw_task_exit'))
    lit(2); lst(poi) # invert po_o[1]
    ljmp(next_sqw) # eliminate a tail call
lbl('sqw_task_exit')
  ret()

lbl('chirp_task') # ->
# chirp task
  lld(chirp_wakeup); lit(t35); lcall(tardy); ljz(fwd('chirp_task_exit'))
    lcall(downchirp)
    ljmp(next_chirp) # eliminate a tail call
lbl('chirp_task_exit')
  ret()

lbl('blink_task') # ->
# blink task
  lld(blink_wakeup); lit(t35); lcall(tardy); ljz(fwd('blink_task_exit'))
    lit(1); lst(poi) # invert po_o[0]
    ljmp(next_blink) # eliminate a tail call
lbl('blink_task_exit')
  ret()

lbl('init')
  lld(t23); lld(sqw_period); add(); lst(sqw_wakeup)
  lld(t35)
  tt(); lld(chirp_period); add(); lst(chirp_wakeup)
  lld(blink_period); add(); lst(blink_wakeup)
lbl('doit')
    lcall(blink_task)
    lcall(chirp_task)
    lcall(sqw_task)
    ljmp(doit)

lbl('app_end') # must be on the last line
