# 12-bit hex numeric USB/UART io amenities

lbl('newline'); ascii('\r\n')

lbl('cr') # ->
# put the cursor on a new line
  lit(newline); ljmp(tx_ascii)

lbl('backspace'); ascii('\b \b')

lbl('bksp') # ->
# back up the cursor
  lit(backspace); ljmp(tx_ascii)

lbl('sp') # ->
# print a space
  lit(ord(' ')); ljmp(tx)

lbl('hex_to_ascii_lut'); ascii('0123456789abcdef')

lbl('hex_to_ascii') # d -> ascii
# translate 4 lsbs of d to an ascii hex character
  lband(0xf); ladd(hex_to_ascii_lut); ld(); ret()

lbl('printx_digit') # d ->
# print d3..0 as a hex digit
  lcall(hex_to_ascii); ljmp(tx)

lbl('printx') # d ->
# print d as 3 hex digits
  tt(); asr(); asr(); asr(); asr() # -> d d'
  tt(); asr(); asr(); asr(); asr() # -> d d' d''
  lcall(printx_digit); lcall(printx_digit); ljmp(printx_digit)

lbl('ascii_to_hex_ascii'); data([0])
#
lbl('ascii_to_hex') # ascii -> d flag
# translate an ascii hex character to a hex digit
# if not a hex character then d will be 0x10 and flag will be 0
  lst(ascii_to_hex_ascii); lit(0) # -> 0
lbl('ascii_to_hex_again')
    tt(); ladd(hex_to_ascii_lut); ld(); lld(ascii_to_hex_ascii); bxor(); ljz(fwd('ascii_to_hex_got'))
      inc(); tt(); lbxor(0x10); ljz(fwd('ascii_to_hex_not'))
        ljmp(ascii_to_hex_again)
lbl('ascii_to_hex_got')
  lit(ALLBITS); ret()
lbl('ascii_to_hex_not')
  lit(0); ret()

lbl('rx_num_num'); data([0])
#
lbl('rx_num') # -> d
# form a 12-bit number from consecutive ascii hex user input
  lit(0); lst(rx_num_num)
lbl('rx_num_again')
    lcall(rx) # -> ascii
    tt(); lcall(tx) # echo
    lcall(ascii_to_hex) # -> digit flag
    ljz(fwd('rx_num_exit')) # -> digit
      lld(rx_num_num); shl(); shl(); shl(); shl() # -> digit num<<4
      bxor(); lst(rx_num_num) # ->
      ljmp(rx_num_again)
lbl('rx_num_exit')
  drop() # ->
  lld(rx_num_num); ret()

lbl('prompt_for') # adr -> d
# prompt for a number
  lcall(tx_ascii) # ->
  ljmp(rx_num)

lbl('print_titled') # d adr ->
# title and print a number
  lcall(tx_ascii) # -> d
  ljmp(printx)
