module smul_tb; // no external inputs or outputs

// inputs
reg [11:0] factor_a_i;
reg [11:0] factor_b_i;

// outputs
wire [23:0] product_o;

// module under test
smul mut (
  .factor_a_i(factor_a_i),
  .factor_b_i(factor_b_i),
  .product_o(product_o)
);

// input stimulus
initial begin

  $display("products are squares of any sign, positive, 2 sign bits");
  factor_a_i = 12'h001; factor_b_i = 12'h001; #1;
  factor_a_i = 12'hfff; factor_b_i = 12'hfff; #1;
  factor_a_i = 12'h7ff; factor_b_i = 12'h7ff; #1;
  factor_a_i = 12'h801; factor_b_i = 12'h801; #1;

  $display("product is a singular square, positive, 1 sign bit");
  factor_a_i = 12'h800; factor_b_i = 12'h800; #1;

  $display("products are minimum, negative, 2 sign bits");
  factor_a_i = 12'h800; factor_b_i = 12'h7ff; #1;
  factor_a_i = 12'h7ff; factor_b_i = 12'h800; #1;

  $display("use the multiplier as a shifter");
  factor_a_i = 12'h010; factor_b_i = 12'hfff; #1;
  factor_a_i = 12'hfff; factor_b_i = 12'h010; #1;
  factor_a_i = 12'h100; factor_b_i = 12'hfff; #1;
  factor_a_i = 12'hfff; factor_b_i = 12'h100; #1;

  $display("end time is%d", $stime);
  $finish;
end

// Icarus Verilog event output
initial
  $monitor(
    "t%t|factor_a_i:%h|factor_b_i:%h|product_o:%h",
    $time,
    factor_a_i,
    factor_b_i,
    product_o
  );

endmodule